#[doc = "Register `APB1HENR` reader"]
pub struct R(crate::R<APB1HENR_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<APB1HENR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<APB1HENR_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<APB1HENR_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `APB1HENR` writer"]
pub struct W(crate::W<APB1HENR_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<APB1HENR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<APB1HENR_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<APB1HENR_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Clock Recovery System peripheral clock enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CRSEN_A {
    #[doc = "0: The selected clock is disabled"]
    Disabled = 0,
    #[doc = "1: The selected clock is enabled"]
    Enabled = 1,
}
impl From<CRSEN_A> for bool {
    #[inline(always)]
    fn from(variant: CRSEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `CRSEN` reader - Clock Recovery System peripheral clock enable"]
pub type CRSEN_R = crate::BitReader<CRSEN_A>;
impl CRSEN_R {
    #[doc = "Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CRSEN_A {
        match self.bits {
            false => CRSEN_A::Disabled,
            true => CRSEN_A::Enabled,
        }
    }
    #[doc = "Checks if the value of the field is `Disabled`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CRSEN_A::Disabled
    }
    #[doc = "Checks if the value of the field is `Enabled`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == CRSEN_A::Enabled
    }
}
#[doc = "Field `CRSEN` writer - Clock Recovery System peripheral clock enable"]
pub type CRSEN_W<'a, const O: u8> = crate::BitWriter<'a, u32, APB1HENR_SPEC, CRSEN_A, O>;
impl<'a, const O: u8> CRSEN_W<'a, O> {
    #[doc = "The selected clock is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CRSEN_A::Disabled)
    }
    #[doc = "The selected clock is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(CRSEN_A::Enabled)
    }
}
#[doc = "SWPMI Peripheral Clocks Enable"]
pub use CRSEN_A as SWPMIEN_A;
#[doc = "OPAMP peripheral clock enable"]
pub use CRSEN_A as OPAMPEN_A;
#[doc = "MDIOS peripheral clock enable"]
pub use CRSEN_A as MDIOSEN_A;
#[doc = "FDCAN Peripheral Clocks Enable"]
pub use CRSEN_A as FDCANEN_A;
#[doc = "TIM23 block enable"]
pub use CRSEN_A as TIM23EN_A;
#[doc = "TIM24 block enable"]
pub use CRSEN_A as TIM24EN_A;
#[doc = "Field `SWPMIEN` reader - SWPMI Peripheral Clocks Enable"]
pub use CRSEN_R as SWPMIEN_R;
#[doc = "Field `OPAMPEN` reader - OPAMP peripheral clock enable"]
pub use CRSEN_R as OPAMPEN_R;
#[doc = "Field `MDIOSEN` reader - MDIOS peripheral clock enable"]
pub use CRSEN_R as MDIOSEN_R;
#[doc = "Field `FDCANEN` reader - FDCAN Peripheral Clocks Enable"]
pub use CRSEN_R as FDCANEN_R;
#[doc = "Field `TIM23EN` reader - TIM23 block enable"]
pub use CRSEN_R as TIM23EN_R;
#[doc = "Field `TIM24EN` reader - TIM24 block enable"]
pub use CRSEN_R as TIM24EN_R;
#[doc = "Field `SWPMIEN` writer - SWPMI Peripheral Clocks Enable"]
pub use CRSEN_W as SWPMIEN_W;
#[doc = "Field `OPAMPEN` writer - OPAMP peripheral clock enable"]
pub use CRSEN_W as OPAMPEN_W;
#[doc = "Field `MDIOSEN` writer - MDIOS peripheral clock enable"]
pub use CRSEN_W as MDIOSEN_W;
#[doc = "Field `FDCANEN` writer - FDCAN Peripheral Clocks Enable"]
pub use CRSEN_W as FDCANEN_W;
#[doc = "Field `TIM23EN` writer - TIM23 block enable"]
pub use CRSEN_W as TIM23EN_W;
#[doc = "Field `TIM24EN` writer - TIM24 block enable"]
pub use CRSEN_W as TIM24EN_W;
impl R {
    #[doc = "Bit 1 - Clock Recovery System peripheral clock enable"]
    #[inline(always)]
    pub fn crsen(&self) -> CRSEN_R {
        CRSEN_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - SWPMI Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn swpmien(&self) -> SWPMIEN_R {
        SWPMIEN_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 4 - OPAMP peripheral clock enable"]
    #[inline(always)]
    pub fn opampen(&self) -> OPAMPEN_R {
        OPAMPEN_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - MDIOS peripheral clock enable"]
    #[inline(always)]
    pub fn mdiosen(&self) -> MDIOSEN_R {
        MDIOSEN_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 8 - FDCAN Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn fdcanen(&self) -> FDCANEN_R {
        FDCANEN_R::new(((self.bits >> 8) & 1) != 0)
    }
    #[doc = "Bit 24 - TIM23 block enable"]
    #[inline(always)]
    pub fn tim23en(&self) -> TIM23EN_R {
        TIM23EN_R::new(((self.bits >> 24) & 1) != 0)
    }
    #[doc = "Bit 25 - TIM24 block enable"]
    #[inline(always)]
    pub fn tim24en(&self) -> TIM24EN_R {
        TIM24EN_R::new(((self.bits >> 25) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 1 - Clock Recovery System peripheral clock enable"]
    #[inline(always)]
    pub fn crsen(&mut self) -> CRSEN_W<1> {
        CRSEN_W::new(self)
    }
    #[doc = "Bit 2 - SWPMI Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn swpmien(&mut self) -> SWPMIEN_W<2> {
        SWPMIEN_W::new(self)
    }
    #[doc = "Bit 4 - OPAMP peripheral clock enable"]
    #[inline(always)]
    pub fn opampen(&mut self) -> OPAMPEN_W<4> {
        OPAMPEN_W::new(self)
    }
    #[doc = "Bit 5 - MDIOS peripheral clock enable"]
    #[inline(always)]
    pub fn mdiosen(&mut self) -> MDIOSEN_W<5> {
        MDIOSEN_W::new(self)
    }
    #[doc = "Bit 8 - FDCAN Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn fdcanen(&mut self) -> FDCANEN_W<8> {
        FDCANEN_W::new(self)
    }
    #[doc = "Bit 24 - TIM23 block enable"]
    #[inline(always)]
    pub fn tim23en(&mut self) -> TIM23EN_W<24> {
        TIM23EN_W::new(self)
    }
    #[doc = "Bit 25 - TIM24 block enable"]
    #[inline(always)]
    pub fn tim24en(&mut self) -> TIM24EN_W<25> {
        TIM24EN_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RCC APB1 Clock Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [apb1henr](index.html) module"]
pub struct APB1HENR_SPEC;
impl crate::RegisterSpec for APB1HENR_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [apb1henr::R](R) reader structure"]
impl crate::Readable for APB1HENR_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [apb1henr::W](W) writer structure"]
impl crate::Writable for APB1HENR_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets APB1HENR to value 0"]
impl crate::Resettable for APB1HENR_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
