#[doc = "Register `FMT0_DR` reader"]
pub struct R(crate::R<FMT0_DR_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<FMT0_DR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<FMT0_DR_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<FMT0_DR_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Field `DR` reader - Parity Error bit"]
pub type DR_R = crate::FieldReader<u32, u32>;
#[doc = "Field `PE` reader - Parity Error bit"]
pub type PE_R = crate::BitReader<bool>;
#[doc = "Field `V` reader - Validity bit"]
pub type V_R = crate::BitReader<bool>;
#[doc = "Field `U` reader - User bit"]
pub type U_R = crate::BitReader<bool>;
#[doc = "Field `C` reader - Channel Status bit"]
pub type C_R = crate::BitReader<bool>;
#[doc = "Field `PT` reader - Preamble Type"]
pub type PT_R = crate::FieldReader<u8, u8>;
impl R {
    #[doc = "Bits 0:23 - Parity Error bit"]
    #[inline(always)]
    pub fn dr(&self) -> DR_R {
        DR_R::new((self.bits & 0x00ff_ffff) as u32)
    }
    #[doc = "Bit 24 - Parity Error bit"]
    #[inline(always)]
    pub fn pe(&self) -> PE_R {
        PE_R::new(((self.bits >> 24) & 1) != 0)
    }
    #[doc = "Bit 25 - Validity bit"]
    #[inline(always)]
    pub fn v(&self) -> V_R {
        V_R::new(((self.bits >> 25) & 1) != 0)
    }
    #[doc = "Bit 26 - User bit"]
    #[inline(always)]
    pub fn u(&self) -> U_R {
        U_R::new(((self.bits >> 26) & 1) != 0)
    }
    #[doc = "Bit 27 - Channel Status bit"]
    #[inline(always)]
    pub fn c(&self) -> C_R {
        C_R::new(((self.bits >> 27) & 1) != 0)
    }
    #[doc = "Bits 28:29 - Preamble Type"]
    #[inline(always)]
    pub fn pt(&self) -> PT_R {
        PT_R::new(((self.bits >> 28) & 3) as u8)
    }
}
#[doc = "Data input register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [fmt0_dr](index.html) module"]
pub struct FMT0_DR_SPEC;
impl crate::RegisterSpec for FMT0_DR_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [fmt0_dr::R](R) reader structure"]
impl crate::Readable for FMT0_DR_SPEC {
    type Reader = R;
}
#[doc = "`reset()` method sets FMT0_DR to value 0"]
impl crate::Resettable for FMT0_DR_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
