#[doc = "Register `APB1LENR` reader"]
pub struct R(crate::R<APB1LENR_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<APB1LENR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<APB1LENR_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<APB1LENR_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `APB1LENR` writer"]
pub struct W(crate::W<APB1LENR_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<APB1LENR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<APB1LENR_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<APB1LENR_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "TIM peripheral clock enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIM2EN_A {
    #[doc = "0: The selected clock is disabled"]
    Disabled = 0,
    #[doc = "1: The selected clock is enabled"]
    Enabled = 1,
}
impl From<TIM2EN_A> for bool {
    #[inline(always)]
    fn from(variant: TIM2EN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `TIM2EN` reader - TIM peripheral clock enable"]
pub type TIM2EN_R = crate::BitReader<TIM2EN_A>;
impl TIM2EN_R {
    #[doc = "Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TIM2EN_A {
        match self.bits {
            false => TIM2EN_A::Disabled,
            true => TIM2EN_A::Enabled,
        }
    }
    #[doc = "Checks if the value of the field is `Disabled`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == TIM2EN_A::Disabled
    }
    #[doc = "Checks if the value of the field is `Enabled`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == TIM2EN_A::Enabled
    }
}
#[doc = "Field `TIM2EN` writer - TIM peripheral clock enable"]
pub type TIM2EN_W<'a, const O: u8> = crate::BitWriter<'a, u32, APB1LENR_SPEC, TIM2EN_A, O>;
impl<'a, const O: u8> TIM2EN_W<'a, O> {
    #[doc = "The selected clock is disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TIM2EN_A::Disabled)
    }
    #[doc = "The selected clock is enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TIM2EN_A::Enabled)
    }
}
#[doc = "TIM peripheral clock enable"]
pub use TIM2EN_A as TIM3EN_A;
#[doc = "TIM peripheral clock enable"]
pub use TIM2EN_A as TIM4EN_A;
#[doc = "TIM peripheral clock enable"]
pub use TIM2EN_A as TIM5EN_A;
#[doc = "TIM peripheral clock enable"]
pub use TIM2EN_A as TIM6EN_A;
#[doc = "TIM peripheral clock enable"]
pub use TIM2EN_A as TIM7EN_A;
#[doc = "TIM peripheral clock enable"]
pub use TIM2EN_A as TIM12EN_A;
#[doc = "TIM peripheral clock enable"]
pub use TIM2EN_A as TIM13EN_A;
#[doc = "TIM peripheral clock enable"]
pub use TIM2EN_A as TIM14EN_A;
#[doc = "LPTIM1 Peripheral Clocks Enable"]
pub use TIM2EN_A as LPTIM1EN_A;
#[doc = "SPI2 Peripheral Clocks Enable"]
pub use TIM2EN_A as SPI2EN_A;
#[doc = "SPI3 Peripheral Clocks Enable"]
pub use TIM2EN_A as SPI3EN_A;
#[doc = "SPDIFRX Peripheral Clocks Enable"]
pub use TIM2EN_A as SPDIFRXEN_A;
#[doc = "USART2 Peripheral Clocks Enable"]
pub use TIM2EN_A as USART2EN_A;
#[doc = "USART3 Peripheral Clocks Enable"]
pub use TIM2EN_A as USART3EN_A;
#[doc = "UART4 Peripheral Clocks Enable"]
pub use TIM2EN_A as UART4EN_A;
#[doc = "UART5 Peripheral Clocks Enable"]
pub use TIM2EN_A as UART5EN_A;
#[doc = "I2C1 Peripheral Clocks Enable"]
pub use TIM2EN_A as I2C1EN_A;
#[doc = "I2C2 Peripheral Clocks Enable"]
pub use TIM2EN_A as I2C2EN_A;
#[doc = "I2C3 Peripheral Clocks Enable"]
pub use TIM2EN_A as I2C3EN_A;
#[doc = "HDMI-CEC peripheral clock enable"]
pub use TIM2EN_A as CECEN_A;
#[doc = "DAC1&2 peripheral clock enable"]
pub use TIM2EN_A as DAC12EN_A;
#[doc = "UART7 Peripheral Clocks Enable"]
pub use TIM2EN_A as UART7EN_A;
#[doc = "UART8 Peripheral Clocks Enable"]
pub use TIM2EN_A as UART8EN_A;
#[doc = "Field `TIM3EN` reader - TIM peripheral clock enable"]
pub use TIM2EN_R as TIM3EN_R;
#[doc = "Field `TIM4EN` reader - TIM peripheral clock enable"]
pub use TIM2EN_R as TIM4EN_R;
#[doc = "Field `TIM5EN` reader - TIM peripheral clock enable"]
pub use TIM2EN_R as TIM5EN_R;
#[doc = "Field `TIM6EN` reader - TIM peripheral clock enable"]
pub use TIM2EN_R as TIM6EN_R;
#[doc = "Field `TIM7EN` reader - TIM peripheral clock enable"]
pub use TIM2EN_R as TIM7EN_R;
#[doc = "Field `TIM12EN` reader - TIM peripheral clock enable"]
pub use TIM2EN_R as TIM12EN_R;
#[doc = "Field `TIM13EN` reader - TIM peripheral clock enable"]
pub use TIM2EN_R as TIM13EN_R;
#[doc = "Field `TIM14EN` reader - TIM peripheral clock enable"]
pub use TIM2EN_R as TIM14EN_R;
#[doc = "Field `LPTIM1EN` reader - LPTIM1 Peripheral Clocks Enable"]
pub use TIM2EN_R as LPTIM1EN_R;
#[doc = "Field `SPI2EN` reader - SPI2 Peripheral Clocks Enable"]
pub use TIM2EN_R as SPI2EN_R;
#[doc = "Field `SPI3EN` reader - SPI3 Peripheral Clocks Enable"]
pub use TIM2EN_R as SPI3EN_R;
#[doc = "Field `SPDIFRXEN` reader - SPDIFRX Peripheral Clocks Enable"]
pub use TIM2EN_R as SPDIFRXEN_R;
#[doc = "Field `USART2EN` reader - USART2 Peripheral Clocks Enable"]
pub use TIM2EN_R as USART2EN_R;
#[doc = "Field `USART3EN` reader - USART3 Peripheral Clocks Enable"]
pub use TIM2EN_R as USART3EN_R;
#[doc = "Field `UART4EN` reader - UART4 Peripheral Clocks Enable"]
pub use TIM2EN_R as UART4EN_R;
#[doc = "Field `UART5EN` reader - UART5 Peripheral Clocks Enable"]
pub use TIM2EN_R as UART5EN_R;
#[doc = "Field `I2C1EN` reader - I2C1 Peripheral Clocks Enable"]
pub use TIM2EN_R as I2C1EN_R;
#[doc = "Field `I2C2EN` reader - I2C2 Peripheral Clocks Enable"]
pub use TIM2EN_R as I2C2EN_R;
#[doc = "Field `I2C3EN` reader - I2C3 Peripheral Clocks Enable"]
pub use TIM2EN_R as I2C3EN_R;
#[doc = "Field `CECEN` reader - HDMI-CEC peripheral clock enable"]
pub use TIM2EN_R as CECEN_R;
#[doc = "Field `DAC12EN` reader - DAC1&2 peripheral clock enable"]
pub use TIM2EN_R as DAC12EN_R;
#[doc = "Field `UART7EN` reader - UART7 Peripheral Clocks Enable"]
pub use TIM2EN_R as UART7EN_R;
#[doc = "Field `UART8EN` reader - UART8 Peripheral Clocks Enable"]
pub use TIM2EN_R as UART8EN_R;
#[doc = "Field `TIM3EN` writer - TIM peripheral clock enable"]
pub use TIM2EN_W as TIM3EN_W;
#[doc = "Field `TIM4EN` writer - TIM peripheral clock enable"]
pub use TIM2EN_W as TIM4EN_W;
#[doc = "Field `TIM5EN` writer - TIM peripheral clock enable"]
pub use TIM2EN_W as TIM5EN_W;
#[doc = "Field `TIM6EN` writer - TIM peripheral clock enable"]
pub use TIM2EN_W as TIM6EN_W;
#[doc = "Field `TIM7EN` writer - TIM peripheral clock enable"]
pub use TIM2EN_W as TIM7EN_W;
#[doc = "Field `TIM12EN` writer - TIM peripheral clock enable"]
pub use TIM2EN_W as TIM12EN_W;
#[doc = "Field `TIM13EN` writer - TIM peripheral clock enable"]
pub use TIM2EN_W as TIM13EN_W;
#[doc = "Field `TIM14EN` writer - TIM peripheral clock enable"]
pub use TIM2EN_W as TIM14EN_W;
#[doc = "Field `LPTIM1EN` writer - LPTIM1 Peripheral Clocks Enable"]
pub use TIM2EN_W as LPTIM1EN_W;
#[doc = "Field `SPI2EN` writer - SPI2 Peripheral Clocks Enable"]
pub use TIM2EN_W as SPI2EN_W;
#[doc = "Field `SPI3EN` writer - SPI3 Peripheral Clocks Enable"]
pub use TIM2EN_W as SPI3EN_W;
#[doc = "Field `SPDIFRXEN` writer - SPDIFRX Peripheral Clocks Enable"]
pub use TIM2EN_W as SPDIFRXEN_W;
#[doc = "Field `USART2EN` writer - USART2 Peripheral Clocks Enable"]
pub use TIM2EN_W as USART2EN_W;
#[doc = "Field `USART3EN` writer - USART3 Peripheral Clocks Enable"]
pub use TIM2EN_W as USART3EN_W;
#[doc = "Field `UART4EN` writer - UART4 Peripheral Clocks Enable"]
pub use TIM2EN_W as UART4EN_W;
#[doc = "Field `UART5EN` writer - UART5 Peripheral Clocks Enable"]
pub use TIM2EN_W as UART5EN_W;
#[doc = "Field `I2C1EN` writer - I2C1 Peripheral Clocks Enable"]
pub use TIM2EN_W as I2C1EN_W;
#[doc = "Field `I2C2EN` writer - I2C2 Peripheral Clocks Enable"]
pub use TIM2EN_W as I2C2EN_W;
#[doc = "Field `I2C3EN` writer - I2C3 Peripheral Clocks Enable"]
pub use TIM2EN_W as I2C3EN_W;
#[doc = "Field `CECEN` writer - HDMI-CEC peripheral clock enable"]
pub use TIM2EN_W as CECEN_W;
#[doc = "Field `DAC12EN` writer - DAC1&2 peripheral clock enable"]
pub use TIM2EN_W as DAC12EN_W;
#[doc = "Field `UART7EN` writer - UART7 Peripheral Clocks Enable"]
pub use TIM2EN_W as UART7EN_W;
#[doc = "Field `UART8EN` writer - UART8 Peripheral Clocks Enable"]
pub use TIM2EN_W as UART8EN_W;
impl R {
    #[doc = "Bit 0 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim2en(&self) -> TIM2EN_R {
        TIM2EN_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim3en(&self) -> TIM3EN_R {
        TIM3EN_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim4en(&self) -> TIM4EN_R {
        TIM4EN_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim5en(&self) -> TIM5EN_R {
        TIM5EN_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim6en(&self) -> TIM6EN_R {
        TIM6EN_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim7en(&self) -> TIM7EN_R {
        TIM7EN_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim12en(&self) -> TIM12EN_R {
        TIM12EN_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim13en(&self) -> TIM13EN_R {
        TIM13EN_R::new(((self.bits >> 7) & 1) != 0)
    }
    #[doc = "Bit 8 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim14en(&self) -> TIM14EN_R {
        TIM14EN_R::new(((self.bits >> 8) & 1) != 0)
    }
    #[doc = "Bit 9 - LPTIM1 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn lptim1en(&self) -> LPTIM1EN_R {
        LPTIM1EN_R::new(((self.bits >> 9) & 1) != 0)
    }
    #[doc = "Bit 14 - SPI2 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn spi2en(&self) -> SPI2EN_R {
        SPI2EN_R::new(((self.bits >> 14) & 1) != 0)
    }
    #[doc = "Bit 15 - SPI3 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn spi3en(&self) -> SPI3EN_R {
        SPI3EN_R::new(((self.bits >> 15) & 1) != 0)
    }
    #[doc = "Bit 16 - SPDIFRX Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn spdifrxen(&self) -> SPDIFRXEN_R {
        SPDIFRXEN_R::new(((self.bits >> 16) & 1) != 0)
    }
    #[doc = "Bit 17 - USART2 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn usart2en(&self) -> USART2EN_R {
        USART2EN_R::new(((self.bits >> 17) & 1) != 0)
    }
    #[doc = "Bit 18 - USART3 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn usart3en(&self) -> USART3EN_R {
        USART3EN_R::new(((self.bits >> 18) & 1) != 0)
    }
    #[doc = "Bit 19 - UART4 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn uart4en(&self) -> UART4EN_R {
        UART4EN_R::new(((self.bits >> 19) & 1) != 0)
    }
    #[doc = "Bit 20 - UART5 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn uart5en(&self) -> UART5EN_R {
        UART5EN_R::new(((self.bits >> 20) & 1) != 0)
    }
    #[doc = "Bit 21 - I2C1 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn i2c1en(&self) -> I2C1EN_R {
        I2C1EN_R::new(((self.bits >> 21) & 1) != 0)
    }
    #[doc = "Bit 22 - I2C2 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn i2c2en(&self) -> I2C2EN_R {
        I2C2EN_R::new(((self.bits >> 22) & 1) != 0)
    }
    #[doc = "Bit 23 - I2C3 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn i2c3en(&self) -> I2C3EN_R {
        I2C3EN_R::new(((self.bits >> 23) & 1) != 0)
    }
    #[doc = "Bit 27 - HDMI-CEC peripheral clock enable"]
    #[inline(always)]
    pub fn cecen(&self) -> CECEN_R {
        CECEN_R::new(((self.bits >> 27) & 1) != 0)
    }
    #[doc = "Bit 29 - DAC1&2 peripheral clock enable"]
    #[inline(always)]
    pub fn dac12en(&self) -> DAC12EN_R {
        DAC12EN_R::new(((self.bits >> 29) & 1) != 0)
    }
    #[doc = "Bit 30 - UART7 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn uart7en(&self) -> UART7EN_R {
        UART7EN_R::new(((self.bits >> 30) & 1) != 0)
    }
    #[doc = "Bit 31 - UART8 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn uart8en(&self) -> UART8EN_R {
        UART8EN_R::new(((self.bits >> 31) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim2en(&mut self) -> TIM2EN_W<0> {
        TIM2EN_W::new(self)
    }
    #[doc = "Bit 1 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim3en(&mut self) -> TIM3EN_W<1> {
        TIM3EN_W::new(self)
    }
    #[doc = "Bit 2 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim4en(&mut self) -> TIM4EN_W<2> {
        TIM4EN_W::new(self)
    }
    #[doc = "Bit 3 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim5en(&mut self) -> TIM5EN_W<3> {
        TIM5EN_W::new(self)
    }
    #[doc = "Bit 4 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim6en(&mut self) -> TIM6EN_W<4> {
        TIM6EN_W::new(self)
    }
    #[doc = "Bit 5 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim7en(&mut self) -> TIM7EN_W<5> {
        TIM7EN_W::new(self)
    }
    #[doc = "Bit 6 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim12en(&mut self) -> TIM12EN_W<6> {
        TIM12EN_W::new(self)
    }
    #[doc = "Bit 7 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim13en(&mut self) -> TIM13EN_W<7> {
        TIM13EN_W::new(self)
    }
    #[doc = "Bit 8 - TIM peripheral clock enable"]
    #[inline(always)]
    pub fn tim14en(&mut self) -> TIM14EN_W<8> {
        TIM14EN_W::new(self)
    }
    #[doc = "Bit 9 - LPTIM1 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn lptim1en(&mut self) -> LPTIM1EN_W<9> {
        LPTIM1EN_W::new(self)
    }
    #[doc = "Bit 14 - SPI2 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn spi2en(&mut self) -> SPI2EN_W<14> {
        SPI2EN_W::new(self)
    }
    #[doc = "Bit 15 - SPI3 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn spi3en(&mut self) -> SPI3EN_W<15> {
        SPI3EN_W::new(self)
    }
    #[doc = "Bit 16 - SPDIFRX Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn spdifrxen(&mut self) -> SPDIFRXEN_W<16> {
        SPDIFRXEN_W::new(self)
    }
    #[doc = "Bit 17 - USART2 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn usart2en(&mut self) -> USART2EN_W<17> {
        USART2EN_W::new(self)
    }
    #[doc = "Bit 18 - USART3 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn usart3en(&mut self) -> USART3EN_W<18> {
        USART3EN_W::new(self)
    }
    #[doc = "Bit 19 - UART4 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn uart4en(&mut self) -> UART4EN_W<19> {
        UART4EN_W::new(self)
    }
    #[doc = "Bit 20 - UART5 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn uart5en(&mut self) -> UART5EN_W<20> {
        UART5EN_W::new(self)
    }
    #[doc = "Bit 21 - I2C1 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn i2c1en(&mut self) -> I2C1EN_W<21> {
        I2C1EN_W::new(self)
    }
    #[doc = "Bit 22 - I2C2 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn i2c2en(&mut self) -> I2C2EN_W<22> {
        I2C2EN_W::new(self)
    }
    #[doc = "Bit 23 - I2C3 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn i2c3en(&mut self) -> I2C3EN_W<23> {
        I2C3EN_W::new(self)
    }
    #[doc = "Bit 27 - HDMI-CEC peripheral clock enable"]
    #[inline(always)]
    pub fn cecen(&mut self) -> CECEN_W<27> {
        CECEN_W::new(self)
    }
    #[doc = "Bit 29 - DAC1&2 peripheral clock enable"]
    #[inline(always)]
    pub fn dac12en(&mut self) -> DAC12EN_W<29> {
        DAC12EN_W::new(self)
    }
    #[doc = "Bit 30 - UART7 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn uart7en(&mut self) -> UART7EN_W<30> {
        UART7EN_W::new(self)
    }
    #[doc = "Bit 31 - UART8 Peripheral Clocks Enable"]
    #[inline(always)]
    pub fn uart8en(&mut self) -> UART8EN_W<31> {
        UART8EN_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RCC APB1 Clock Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [apb1lenr](index.html) module"]
pub struct APB1LENR_SPEC;
impl crate::RegisterSpec for APB1LENR_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [apb1lenr::R](R) reader structure"]
impl crate::Readable for APB1LENR_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [apb1lenr::W](W) writer structure"]
impl crate::Writable for APB1LENR_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets APB1LENR to value 0"]
impl crate::Resettable for APB1LENR_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
